{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "bcftools",
                "view"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#call_snvs.cwl/input_gbcf"
                },
                {
                    "type": "string",
                    "default": "snps",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-v"
                    },
                    "id": "#call_snvs.cwl/types"
                },
                {
                    "type": "string",
                    "default": "v",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-O"
                    },
                    "id": "#call_snvs.cwl/variant_format"
                }
            ],
            "arguments": [
                "-o",
                "$(inputs.input_gbcf.nameroot).vcf"
            ],
            "id": "#call_snvs.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_gbcf.nameroot).vcf"
                    },
                    "id": "#call_snvs.cwl/output_vcf"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "filter_known_snp.py"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--input"
                    },
                    "id": "#filter_known_snp.cwl/input_eff"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--known"
                    },
                    "id": "#filter_known_snp.cwl/known_snp"
                }
            ],
            "arguments": [
                "--output",
                "$(inputs.input_eff.nameroot).snpfiltered.vcf"
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_eff.nameroot).snpfiltered.vcf"
                    },
                    "id": "#filter_known_snp.cwl/output_vcf"
                }
            ],
            "id": "#filter_known_snp.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "filter_reads.py"
            ],
            "inputs": [
                {
                    "type": "int",
                    "default": 5,
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--edge_mutation"
                    },
                    "id": "#filter_reads.cwl/edge_mutation"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--input"
                    },
                    "id": "#filter_reads.cwl/input_unfiltered_bam"
                },
                {
                    "type": "int",
                    "default": 10,
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--junction_overhang"
                    },
                    "id": "#filter_reads.cwl/junction_overhang"
                },
                {
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--non_ag_threshold"
                    },
                    "id": "#filter_reads.cwl/non_ag"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--reverse-strand"
                    },
                    "id": "#filter_reads.cwl/reverse_stranded_library"
                }
            ],
            "arguments": [
                "--output",
                "$(inputs.input_unfiltered_bam.nameroot).readfiltered.bam"
            ],
            "outputs": [
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_2572",
                    "outputBinding": {
                        "glob": "$(inputs.input_unfiltered_bam.nameroot).readfiltered.bam"
                    },
                    "label": "",
                    "doc": "filtered bam",
                    "id": "#filter_reads.cwl/output_bam"
                }
            ],
            "id": "#filter_reads.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "filter_variants.py"
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--dp"
                    },
                    "id": "#filter_variants.cwl/dp"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i"
                    },
                    "id": "#filter_variants.cwl/input_vcf"
                },
                {
                    "type": "int",
                    "default": 10,
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-m"
                    },
                    "id": "#filter_variants.cwl/min_variant_coverage"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--reverse-split"
                    },
                    "id": "#filter_variants.cwl/reverse_split_bam"
                }
            ],
            "arguments": [
                "-o",
                "$(inputs.input_vcf.nameroot).varfiltered.vcf"
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_vcf.nameroot).varfiltered.vcf"
                    },
                    "id": "#filter_variants.cwl/output_vcf"
                }
            ],
            "id": "#filter_variants.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "bcftools",
                "call"
            ],
            "inputs": [
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-A"
                    },
                    "id": "#format_variants.cwl/call_alts"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#format_variants.cwl/input_gbcf"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-c"
                    },
                    "id": "#format_variants.cwl/use_consensus_caller"
                },
                {
                    "type": "string",
                    "default": "v",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-O"
                    },
                    "id": "#format_variants.cwl/variant_format"
                }
            ],
            "arguments": [
                "-o",
                "$(inputs.input_gbcf.nameroot).formatted.vcf"
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_gbcf.nameroot).formatted.vcf"
                    },
                    "id": "#format_variants.cwl/output_vcf"
                }
            ],
            "id": "#format_variants.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "samtools",
                "mpileup"
            ],
            "inputs": [
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "position": 6,
                        "prefix": "-g"
                    },
                    "id": "#mpileup.cwl/bcf_format"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-E"
                    },
                    "id": "#mpileup.cwl/calculate_baq"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-p"
                    },
                    "id": "#mpileup.cwl/calculate_per_sample"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 7,
                        "prefix": "-I"
                    },
                    "id": "#mpileup.cwl/input_bam"
                },
                {
                    "type": "int",
                    "default": 1000,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-d"
                    },
                    "id": "#mpileup.cwl/max_depth"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-f"
                    },
                    "id": "#mpileup.cwl/reference"
                },
                {
                    "type": "string",
                    "default": "DP,DV,DPR,INFO/DPR,DP4,SP",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-t"
                    },
                    "id": "#mpileup.cwl/tags"
                }
            ],
            "arguments": [
                "-o",
                "$(inputs.input_bam.nameroot).gbcf"
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_bam.nameroot).gbcf"
                    },
                    "id": "#mpileup.cwl/output_gbcf"
                }
            ],
            "id": "#mpileup.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "rank_edits.py"
            ],
            "inputs": [
                {
                    "type": "int",
                    "default": 0,
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-a"
                    },
                    "id": "#rank_edits.cwl/alpha"
                },
                {
                    "type": "int",
                    "default": 0,
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-b"
                    },
                    "id": "#rank_edits.cwl/beta"
                },
                {
                    "type": "float",
                    "default": 0.01,
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-c"
                    },
                    "id": "#rank_edits.cwl/edit_fraction"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-i"
                    },
                    "id": "#rank_edits.cwl/input_noSNP"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--keep-100-edited"
                    },
                    "id": "#rank_edits.cwl/keep_all_edited"
                }
            ],
            "arguments": [
                "--output",
                "$(inputs.input_noSNP.nameroot).ranked.conf"
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_noSNP.nameroot).ranked.bed"
                    },
                    "id": "#rank_edits.cwl/output_bed"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_noSNP.nameroot).ranked.conf"
                    },
                    "id": "#rank_edits.cwl/output_conf"
                }
            ],
            "id": "#rank_edits.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "ifnotskip"
            ],
            "arguments": [
                "samtools",
                "rmdup"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "label": "duped bam",
                    "doc": "duped bam",
                    "id": "#rmdup.cwl/duped_bam"
                },
                {
                    "type": "string",
                    "default": "rmduped.bam",
                    "inputBinding": {
                        "position": 2,
                        "valueFrom": "$(inputs.duped_bam.nameroot).rmdup.bam"
                    },
                    "id": "#rmdup.cwl/rm_bam"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "prefix": "-s",
                        "position": 3
                    },
                    "id": "#rmdup.cwl/single_end"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "inputBinding": {
                        "position": -1,
                        "prefix": "--skip"
                    },
                    "id": "#rmdup.cwl/skip_duplicate_removal"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.duped_bam.nameroot).rmdup.bam"
                    },
                    "id": "#rmdup.cwl/output_bam"
                }
            ],
            "id": "#rmdup.cwl"
        },
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": "int",
                    "default": 0,
                    "id": "#main/alpha"
                },
                {
                    "type": "int",
                    "default": 0,
                    "id": "#main/beta"
                },
                {
                    "type": "string",
                    "default": "DP4",
                    "id": "#main/dp"
                },
                {
                    "type": "int",
                    "default": 5,
                    "id": "#main/edge_mutation"
                },
                {
                    "type": "float",
                    "default": 0.01,
                    "id": "#main/edit_fraction"
                },
                {
                    "type": "File",
                    "id": "#main/input_unsorted_bam"
                },
                {
                    "type": "int",
                    "default": 10,
                    "id": "#main/junction_overhang"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "id": "#main/keep_all_edited"
                },
                {
                    "type": "File",
                    "id": "#main/known_snp"
                },
                {
                    "type": "int",
                    "default": 5,
                    "id": "#main/min_variant_coverage"
                },
                {
                    "type": "int",
                    "default": 1,
                    "id": "#main/non_ag"
                },
                {
                    "type": "File",
                    "id": "#main/reference"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "id": "#main/reverse_split_bam"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "id": "#main/reverse_stranded_library"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "id": "#main/single_end"
                },
                {
                    "type": "boolean",
                    "default": false,
                    "id": "#main/skip_duplicate_removal"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "id": "#main/variants_only"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/call_snvs/output_vcf",
                    "id": "#main/call_snvs_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/filter_known_snp/output_vcf",
                    "id": "#main/filter_known_snp_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/filter_variants/output_vcf",
                    "id": "#main/filter_variants_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/filter_reads/output_bam",
                    "id": "#main/filtered_bam_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/format_variants/output_vcf",
                    "id": "#main/format_variants_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/mpileup/output_gbcf",
                    "id": "#main/mpileup_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/rank_edits/output_conf",
                    "id": "#main/rank_edits_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/rank_edits/output_bed",
                    "id": "#main/rank_edits_output_bed"
                },
                {
                    "type": "File",
                    "outputSource": "#main/rmdup/output_bam",
                    "id": "#main/rmdup_bam_output"
                },
                {
                    "type": "File",
                    "outputSource": "#main/sort/output_bam",
                    "id": "#main/sorted_bam_output"
                }
            ],
            "steps": [
                {
                    "run": "#call_snvs.cwl",
                    "in": [
                        {
                            "source": "#main/mpileup/output_gbcf",
                            "id": "#main/call_snvs/input_gbcf"
                        }
                    ],
                    "out": [
                        "#main/call_snvs/output_vcf"
                    ],
                    "id": "#main/call_snvs"
                },
                {
                    "run": "#filter_known_snp.cwl",
                    "in": [
                        {
                            "source": "#main/filter_variants/output_vcf",
                            "id": "#main/filter_known_snp/input_eff"
                        },
                        {
                            "source": "#main/known_snp",
                            "id": "#main/filter_known_snp/known_snp"
                        }
                    ],
                    "out": [
                        "#main/filter_known_snp/output_vcf"
                    ],
                    "id": "#main/filter_known_snp"
                },
                {
                    "run": "#filter_reads.cwl",
                    "in": [
                        {
                            "source": "#main/edge_mutation",
                            "id": "#main/filter_reads/edge_mutation"
                        },
                        {
                            "source": "#main/rmdup/output_bam",
                            "id": "#main/filter_reads/input_unfiltered_bam"
                        },
                        {
                            "source": "#main/junction_overhang",
                            "id": "#main/filter_reads/junction_overhang"
                        },
                        {
                            "source": "#main/non_ag",
                            "id": "#main/filter_reads/non_ag"
                        },
                        {
                            "source": "#main/reverse_stranded_library",
                            "id": "#main/filter_reads/reverse_stranded_library"
                        }
                    ],
                    "out": [
                        "#main/filter_reads/output_bam"
                    ],
                    "id": "#main/filter_reads"
                },
                {
                    "run": "#filter_variants.cwl",
                    "in": [
                        {
                            "source": "#main/dp",
                            "id": "#main/filter_variants/dp"
                        },
                        {
                            "source": "#main/format_variants/output_vcf",
                            "id": "#main/filter_variants/input_vcf"
                        },
                        {
                            "source": "#main/min_variant_coverage",
                            "id": "#main/filter_variants/min_variant_coverage"
                        },
                        {
                            "source": "#main/reverse_split_bam",
                            "id": "#main/filter_variants/reverse_split_bam"
                        }
                    ],
                    "out": [
                        "#main/filter_variants/output_vcf"
                    ],
                    "id": "#main/filter_variants"
                },
                {
                    "run": "#format_variants.cwl",
                    "in": [
                        {
                            "source": "#main/call_snvs/output_vcf",
                            "id": "#main/format_variants/input_gbcf"
                        }
                    ],
                    "out": [
                        "#main/format_variants/output_vcf"
                    ],
                    "id": "#main/format_variants"
                },
                {
                    "run": "#mpileup.cwl",
                    "in": [
                        {
                            "source": "#main/filter_reads/output_bam",
                            "id": "#main/mpileup/input_bam"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/mpileup/reference"
                        }
                    ],
                    "out": [
                        "#main/mpileup/output_gbcf"
                    ],
                    "id": "#main/mpileup"
                },
                {
                    "run": "#rank_edits.cwl",
                    "in": [
                        {
                            "source": "#main/alpha",
                            "id": "#main/rank_edits/alpha"
                        },
                        {
                            "source": "#main/beta",
                            "id": "#main/rank_edits/beta"
                        },
                        {
                            "source": "#main/edit_fraction",
                            "id": "#main/rank_edits/edit_fraction"
                        },
                        {
                            "source": "#main/filter_known_snp/output_vcf",
                            "id": "#main/rank_edits/input_noSNP"
                        },
                        {
                            "source": "#main/keep_all_edited",
                            "id": "#main/rank_edits/keep_all_edited"
                        }
                    ],
                    "out": [
                        "#main/rank_edits/output_conf",
                        "#main/rank_edits/output_bed"
                    ],
                    "id": "#main/rank_edits"
                },
                {
                    "run": "#rmdup.cwl",
                    "in": [
                        {
                            "source": "#main/sort/output_bam",
                            "id": "#main/rmdup/duped_bam"
                        },
                        {
                            "source": "#main/single_end",
                            "id": "#main/rmdup/single_end"
                        },
                        {
                            "source": "#main/skip_duplicate_removal",
                            "id": "#main/rmdup/skip_duplicate_removal"
                        }
                    ],
                    "out": [
                        "#main/rmdup/output_bam"
                    ],
                    "id": "#main/rmdup"
                },
                {
                    "run": "#sort.cwl",
                    "in": [
                        {
                            "source": "#main/input_unsorted_bam",
                            "id": "#main/sort/input_unsorted_bam"
                        }
                    ],
                    "out": [
                        "#main/sort/output_bam"
                    ],
                    "id": "#main/sort"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "samtools",
                "sort"
            ],
            "inputs": [
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_2572",
                    "inputBinding": {
                        "position": 1
                    },
                    "label": "input bam",
                    "doc": "input bam",
                    "id": "#sort.cwl/input_unsorted_bam"
                }
            ],
            "arguments": [
                "-o",
                "$(inputs.input_unsorted_bam.nameroot).sorted.bam"
            ],
            "outputs": [
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_2572",
                    "outputBinding": {
                        "glob": "$(inputs.input_unsorted_bam.nameroot).sorted.bam"
                    },
                    "label": "",
                    "doc": "sorted bam",
                    "id": "#sort.cwl/output_bam"
                }
            ],
            "id": "#sort.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
